import 'dart:convert';

import 'package:socket_mvvm/socket/config/SocketConfig.dart';
import 'package:web_socket_channel/io.dart';

abstract class BaseRepository {
  String _socketUrl;
  bool _isSub;
  bool _isClose;
  IOWebSocketChannel _channel;

  BaseRepository() {
    _socketUrl = SocketConfig.url;
    _isSub = true;
    _isClose = false;
    _channel = IOWebSocketChannel.connect(_socketUrl,
        pingInterval: Duration(seconds: 2));
  }

  bool get isClose => _isClose;

  set isClose(bool value) {
    _isClose = value;
  }

  getSocketData() {
    String pong = {
      "\"op\"": "\"pong\"",
      "\"ts\"": "\"${DateTime.now().millisecond}\""
    }.toString();
    _channel.sink.add(pong);
    _channel.stream.listen((data) async {
      if (isClose) {
        _channel.sink.close();
        return;
      }
      var decode = json.decode(data);
      if (decode.containsKey("ts")) {
        if (_isSub) {
          _channel.sink.add(getDataRequest());
        }
        _channel.sink.add(pong);
        _isSub = false;
      }
      print("tag===decode===>$decode");
      if (decode.containsKey("topic")) {
        if (decode.containsKey("tick")) {
          jsonToEntity(decode);
        } else {
          jsonToEntity(null);
        }
      }
    }, onError: (e) {
      throw e;
    });
  }

  String getDataRequest();

  void jsonToEntity(decode);
}
